import { ASTNode } from "../types/token.ts";

export class NGNKGenerator {
    generate(ast: ASTNode): string {
        if (!ast) return "";

        switch (ast.type) {
            case "FunctionCall":
                return `${ast.name}[${ast.args.map(arg => this.generate(arg)).join(";")}]`;
            
            case "Indexing":
                return `${ast.name}[${ast.args.map(arg => this.generate(arg)).join(";")}]`;
            
            case "BinaryExpression":
                return `${this.generate(ast.left)} ${ast.operator} ${this.generate(ast.right)}`;
            
            case "UnaryExpression":
                return `${this.generate(ast.operand)} ${ast.operator}`;
            
            case "Number":
            case "Identifier":
                return ast.value;
            
            default:
                return "";
        }
    }
} 